#ifndef _CFM_AL_H_
#define _CFM_AL_H_

#ifdef __cplusplus
extern "C" {
#endif

// function pointer typedefs
typedef ALvoid	(*alEnablePtr)( ALenum capability );
typedef ALvoid	(*alDisablePtr)( ALenum capability ); 
typedef ALboolean (*alIsEnabledPtr)( ALenum capability ); 
typedef ALvoid	(*alHintPtr)( ALenum target, ALenum mode );
typedef ALboolean (*alGetBooleanPtr)( ALenum param );
typedef ALint		(*alGetIntegerPtr)( ALenum param );
typedef ALfloat	(*alGetFloatPtr)( ALenum param );
typedef ALdouble	(*alGetDoublePtr)( ALenum param );
typedef ALvoid	(*alGetBooleanvPtr)( ALenum param, ALboolean* data );
typedef ALvoid	(*alGetIntegervPtr)( ALenum param, ALint* data );
typedef ALvoid	(*alGetFloatvPtr)( ALenum param, ALfloat* data );
typedef ALvoid	(*alGetDoublevPtr)( ALenum param, ALdouble* data );
typedef ALubyte*	(*alGetStringPtr)( ALenum param );
typedef ALenum	(*alGetErrorPtr)( ALvoid );
typedef ALboolean (*alIsExtensionPresentPtr)( ALubyte* fname );
typedef ALvoid*	(*alGetProcAddressPtr)( ALubyte* fname );
typedef ALenum	(*alGetEnumValuePtr)( ALubyte* ename );
typedef ALvoid	(*alListeneriPtr)( ALenum param, ALint value );
typedef ALvoid	(*alListenerfPtr)( ALenum param, ALfloat value );
typedef ALvoid	(*alListener3fPtr)( ALenum param, ALfloat v1, ALfloat v2, ALfloat v3 ); 
typedef ALvoid	(*alListenerfvPtr)( ALenum param, ALfloat* values ); 
typedef ALvoid	(*alGetListeneriPtr)( ALenum param, ALint* value );
typedef ALvoid	(*alGetListenerfPtr)( ALenum param, ALfloat* value );
typedef ALvoid	(*alGetListener3fPtr)( ALenum param, ALfloat* v1, ALfloat* v2, ALfloat* v3 ); 
typedef ALvoid	(*alGetListenerfvPtr)( ALenum param, ALfloat* values ); 
typedef ALvoid	(*alGenSourcesPtr)( ALsizei n, ALuint* sources ); 
typedef ALvoid	(*alDeleteSourcesPtr)( ALsizei n, ALuint* sources );
typedef ALboolean (*alIsSourcePtr)( ALuint id ); 
typedef ALvoid	(*alSourceiPtr)( ALuint source, ALenum param, ALint value ); 
typedef ALvoid	(*alSourcefPtr)( ALuint source, ALenum param, ALfloat value ); 
typedef ALvoid	(*alSource3fPtr)( ALuint source, ALenum param, ALfloat v1, ALfloat v2, ALfloat v3 );
typedef ALvoid	(*alSourcefvPtr)( ALuint source, ALenum param, ALfloat* values ); 
typedef ALvoid	(*alGetSourceiPtr)( ALuint source,  ALenum param, ALint* value );
typedef ALvoid	(*alGetSourcefPtr)( ALuint source,  ALenum param, ALfloat* value );
typedef ALvoid	(*alGetSourcefvPtr)( ALuint source, ALenum param, ALfloat* values );
typedef ALvoid	(*alSourcePlayvPtr)( ALsizei n, ALuint *sources );
typedef ALvoid	(*alSourceStopvPtr)( ALsizei n, ALuint *sources );
typedef ALvoid	(*alSourcePlayPtr)( ALuint source );
typedef ALvoid	(*alSourcePausePtr)( ALuint source );
typedef ALvoid	(*alSourceStopPtr)( ALuint source );
typedef ALvoid 	(*alGenBuffersPtr)( ALsizei n, ALuint* buffers );
typedef ALvoid	(*alDeleteBuffersPtr)( ALsizei n, ALuint* buffers );
typedef ALboolean (*alIsBufferPtr)( ALuint buffer );
typedef ALvoid	(*alBufferDataPtr)( ALuint   buffer, 
									ALenum   format,
									ALvoid*  data,
									ALsizei  size,
									ALsizei  freq );
typedef ALvoid	(*alGetBufferiPtr)( ALuint buffer, ALenum param, ALint*   value );
typedef ALvoid	(*alGetBufferfPtr)( ALuint buffer, ALenum param, ALfloat* value );
typedef ALvoid	(*alSourceQueueBuffersPtr)( ALuint source, ALsizei n, ALuint* buffers );
typedef ALvoid	(*alSourceUnqueueBuffersPtr)( ALuint source, ALsizei n, ALuint* buffers );
typedef ALvoid	(*alDistanceModelPtr)( ALenum value );
typedef ALvoid	(*alDopplerFactorPtr)( ALfloat value );
typedef ALvoid	(*alDopplerVelocityPtr)( ALfloat value );


extern alEnablePtr pfalEnable;
extern alDisablePtr pfalDisable;
extern alIsEnabledPtr pfalIsEnabled;
extern alHintPtr pfalHint;
extern alGetBooleanPtr pfalGetBoolean;
extern alGetIntegerPtr pfalGetInteger;
extern alGetFloatPtr pfalGetFloat;
extern alGetDoublePtr pfalGetDouble;
extern alGetBooleanvPtr pfalGetBooleanv;
extern alGetIntegervPtr pfalGetIntegerv;
extern alGetFloatvPtr pfalGetFloatv;
extern alGetDoublevPtr pfalGetDoublev;
extern alGetStringPtr pfalGetString;
extern alGetErrorPtr pfalGetError;
extern alIsExtensionPresentPtr pfalIsExtensionPresent;
extern alGetProcAddressPtr pfalGetProcAddress;
extern alGetEnumValuePtr pfalGetEnumValue;
extern alListeneriPtr pfalListeneri;
extern alListenerfPtr pfalListenerf;
extern alListener3fPtr pfalListener3f; 
extern alListenerfvPtr pfalListenerfv; 
extern alGetListeneriPtr pfalGetListeneri;
extern alGetListenerfPtr pfalGetListenerf;
extern alGetListener3fPtr pfalGetListener3f; 
extern alGetListenerfvPtr pfalGetListenerfv; 
extern alGenSourcesPtr pfalGenSources; 
extern alDeleteSourcesPtr pfalDeleteSources;
extern alIsSourcePtr pfalIsSource; 
extern alSourceiPtr pfalSourcei;
extern alSourcefPtr pfalSourcef; 
extern alSource3fPtr pfalSource3f;
extern alSourcefvPtr pfalSourcefv; 
extern alGetSourceiPtr pfalGetSourcei;
extern alGetSourcefPtr pfalGetSourcef;
extern alGetSourcefvPtr pfalGetSourcefv;
extern alSourcePlayvPtr pfalSourcePlayv;
extern alSourceStopvPtr pfalSourceStopv;
extern alSourcePlayPtr pfalSourcePlay;
extern alSourcePausePtr pfalSourcePause;
extern alSourceStopPtr pfalSourceStop;
extern alGenBuffersPtr pfalGenBuffers;
extern alDeleteBuffersPtr pfalDeleteBuffers;
extern alIsBufferPtr pfalIsBuffer;
extern alBufferDataPtr pfalBufferData;
extern alGetBufferiPtr pfalGetBufferi;
extern alGetBufferfPtr pfalGetBufferf;
extern alSourceQueueBuffersPtr pfalSourceQueueBuffers;
extern alSourceUnqueueBuffersPtr pfalSourceUnqueueBuffers;
extern alDistanceModelPtr pfalDistanceModel;
extern alDopplerFactorPtr pfalDopplerFactor;
extern alDopplerVelocityPtr pfalDopplerVelocity;

#ifdef __cplusplus
}
#endif

#endif //_CFM_AL_H_
