#ifndef _CFM_ALU_H_
#define _CFM_ALU_H_

#define BUFFERSIZE 48000
#define FRACTIONBITS 14
#define FRACTIONMASK ((1L<<FRACTIONBITS)-1)
#define OUTPUTCHANNELS 2

#ifdef __cplusplus
extern "C" {
#endif

typedef ALint	(*aluF2LPtr)( ALfloat value );
typedef ALshort	(*aluF2SPtr)( ALfloat value );
typedef ALvoid	(*aluCrossproductPtr)( ALfloat *inVector1, ALfloat *inVector2, ALfloat *outVector );
typedef ALfloat	(*aluDotproductPtr)( ALfloat *inVector1, ALfloat *inVector2 );
typedef ALvoid	(*aluNormalizePtr)( ALfloat *inVector );
typedef ALvoid	(*aluMatrixVectorPtr)( ALfloat matrix[3][3], ALfloat *vector );
typedef ALvoid	(*aluCalculateSourceParametersPtr)( ALuint source, ALuint channels, ALfloat *drysend, ALfloat *wetsend, ALfloat *pitch );
typedef ALvoid	(*aluMixDataPtr)( ALvoid *context, ALvoid *buffer, ALsizei size, ALenum format );
typedef ALvoid	(*aluSetReverbPtr)( ALvoid *Reverb, ALuint Environment );
typedef ALvoid	(*aluReverbPtr)( ALvoid *Reverb, ALfloat Buffer[][2], ALsizei BufferSize );

extern aluF2LPtr pfaluF2L;
extern aluF2SPtr pfaluF2S;
extern aluCrossproductPtr pfaluCrossproduct;
extern aluDotproductPtr pfaluDotproduct;
extern aluNormalizePtr pfaluNormalize;
extern aluMatrixVectorPtr pfaluMatrixVector;
extern aluCalculateSourceParametersPtr pfaluCalculateSourceParameters;
extern aluMixDataPtr pfaluMixData;
extern aluSetReverbPtr pfaluSetReverb;
extern aluReverbPtr pfaluReverb;

#ifdef __cplusplus
}
#endif

#endif //_CFM_ALU_H_
